﻿using KitchenRoot;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WpfKitchen
{
	public class TreeNodeList : XObjectListNotifier<TreeNode>
	{
		public TreeNodeList() : base()
		{

		}

		public TreeNode this[string title]
		{
			get { return this.FirstOrDefault(i => i.Title == title); }
		}

		public List<TreeNode> FlatList
		{
			get
			{
				List<TreeNode>	List	= new List<TreeNode>();

				List.AddRange(this);
				foreach(TreeNode node in this)
				{
					if(node.Children == null)
						continue;

					List.AddRange(node.Children.FlatList);
				}
				return List;
			}
		}

		public bool HasSelection
		{
			get { return FlatList.Any( item => item.IsSelected == true); }
		}

		public TreeNode FirstSelectedDescendant
		{
			get { return this.FlatList.FirstOrDefault(c => c.IsSelected == true); }
		}
	}
}
