﻿using System;
using System.ComponentModel;
using System.Linq.Expressions;

namespace KitchenRoot
{

	//[DataContract]
	public abstract class XObjectNotifier : INotifyPropertyChanged
	{

		public event PropertyChangedEventHandler		PropertyChanged;

		protected void NotifyPropertyChanged<TProperty>(Expression<Func<TProperty>> property)
		{
			if (property == null || PropertyChanged == null)
				return;

			var expression	= property.Body as MemberExpression;

			if( expression == null)
				return;

			string	name = expression.Member.Name;	// property.Name;
			NotifyPropertyChanged( name);
		}

		protected void NotifyPropertyChanged(string property_name)
		{
			if( PropertyChanged == null || string.IsNullOrEmpty( property_name))
				return;

			PropertyChanged.Invoke( this, new PropertyChangedEventArgs( property_name));
		}

	}
}
