﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfKitchen.controls
{
    /// <summary>
    /// Interaction logic for TreeViewX.xaml
    /// </summary>
    public partial class MultiNodeTypeTreeView : UserControl
    {
		public MultiNodeTypeTreeView()
        {
            InitializeComponent();
        }

		private void TreeView_Loaded(object sender, RoutedEventArgs e)
		{
			ExpandTreeItems( treeview1, true);
		}


		private void ExpandTreeItems(ItemsControl tv, bool recurse)
		{
			if (tv == null)
				return;

			foreach (Object tvitem in tv.Items)
			{
				TreeViewItem	currentContainer = tv.ItemContainerGenerator.ContainerFromItem(tvitem) as TreeViewItem;

				if (currentContainer != null && currentContainer.Items.Count > 0)
				{
					// Expand the current item. 
					currentContainer.IsExpanded = true;

					if (recurse)
					{
						//if (currentContainer.ItemContainerGenerator.Status != GeneratorStatus.ContainersGenerated)
						//{
						//	// If the sub containers of current item is not ready, we need to wait until 
						//	// they are generated. 
						//	currentContainer.ItemContainerGenerator.StatusChanged += delegate
						//	{
						//		ExpandTreeItems(currentContainer, recurse);
						//	};
						//}
						//else
						{
							// If the sub containers of current item is ready, we can directly go to the next 
							// iteration to expand them. 
							ExpandTreeItems(currentContainer, recurse);
						} 
					}
				}

			}
		}


    }
}
